/***************************************************************************
                          s_internal_loop.h  -  description
                             -------------------
    begin                : Fri Apr 12 2002
    copyright            : (C) 2002 by Mirela Andronescu
    email                : andrones@cs.ubc.ca
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef S_INTERNAL_LOOP_H
#define S_INTERNAL_LOOP_H

#include "constants.h"
#include "structs.h"
#include "s_energy_matrix.h"

/*
struct internal_node
{
    int energy;
    pair prime;

    internal_node ()
    {
        energy = INF;
        prime.i = -1;
        prime.j = -1;
    }

    void copy (const internal_node &inode)
    {
        energy = inode.energy;
        prime.i = inode.prime.i;
        prime.j = inode.prime.j;
    }
};
*/

class s_internal_loop
{
    public:

        friend class s_energy_matrix;

        s_internal_loop (int *seq, int length);
        // The constructor

        ~s_internal_loop ();
        // The destructor

        void set_energy_matrix (s_energy_matrix *V) { this->V = V; }
        // PRE:  None
        // POST: Set local energy matrix to V

        int compute_energy (int i, int j);
        // computes the MFE of the structure closed by an internal loop closed at (i,j)

        int get_energy_str (int i, int j, int ip, int jp);
        // returns the free energy of the structure closed by the internal loop (i,j,ip,jp)        
        
        static int get_energy (int i, int j, int ip, int jp, int *sequence);
        // returns the free energy of the internal loop closed at (i,j,ip,jp)
        
        static int get_enthalpy (int i, int j, int ip, int jp, int *sequence);
        // returns the enthalpy of the internal loop closed at (i,j,ip,jp)
        
    private:
        int *sequence;                 // the entire sequence for which we compute the energy
        int seqlen;                     // sequence length
        s_energy_matrix *V;               // a pointer to the free energy matrix V   
        
};

#endif
